<template>
  <div class="seats-actions">
    <v-tooltip bottom>
      <template #activator="{ props }">
        <v-btn class="mr-2 flashy" data-cy="SeatsActionsZoomInBtn" v-bind="props" @click="zoomIn()" tile icon size="x-small"
          >
          <v-icon>zoom_in</v-icon>
        </v-btn>
      </template>
      <span>Zoomer</span>
    </v-tooltip>
    <v-tooltip bottom>
      <template #activator="{ props }">
        <v-btn class="mr-2 flashy" data-cy="SeatsActionsZoomOutBtn" v-bind="props" @click="zoomOut()" tile icon size="x-small"
          >
          <v-icon>zoom_out</v-icon>
        </v-btn>
      </template>
      <span>Dézoomer</span>
    </v-tooltip>
    <v-tooltip bottom>
      <template #activator="{ props }">
        <v-btn class="mr-2 flashy" data-cy="SeatsActionsPlaceModeBtn" v-bind="props"
          :class="{ 'active': modes.placeMode }" @click="changeMode('placeMode')" tile icon size="x-small" :disabled="archived"
          >
          <v-icon>touch_app</v-icon>
        </v-btn>
      </template>
      <span>Placer</span>
    </v-tooltip>
    <v-tooltip bottom>
      <template #activator="{ props }">
        <v-btn class="mr-2 flashy" data-cy="SeatsActionsBlockModeBtn" v-bind="props"
          :class="{ 'active': modes.blockMode }" @click="changeMode('blockMode')" tile icon size="x-small" :disabled="archived"
          >
          <v-icon>lock</v-icon>
        </v-btn>
      </template>
      <span>Bloquer</span>
    </v-tooltip>
    <v-tooltip bottom>
      <template #activator="{ props }">
        <v-btn class="mr-2 flashy" data-cy="SeatsActionsCommentModeBtn" v-bind="props"
          :class="{ 'active': modes.commentMode }" tile icon @click="changeMode('commentMode')" size="x-small"
          :disabled="archived">
          <v-icon>chat_bubble_outline</v-icon>
        </v-btn>
      </template>
      <span>Commenter</span>
    </v-tooltip>
    <v-menu offset-y :close-on-content-click="false">
      <template #activator="{ props: menu }">
        <v-tooltip bottom>
          <template #activator="{ props: tooltip }">
            <v-btn class="mr-2 flashy" data-cy="SeatsActionsLegendBtn" v-bind="mergeProps(menu, tooltip)"
              v-on="{ ...tooltip, ...menu }" tile icon size="x-small">
              <v-icon>format_list_bulleted</v-icon>
            </v-btn>
          </template>
          <span>Légende</span>
        </v-tooltip>
      </template>
      <FlightsCaseSeatsSeatLegend />
    </v-menu>
    <v-tooltip bottom>
      <template #activator="{ props }">
        <v-btn class="flashy" data-cy="SeatsActionsFullscreenBtn" v-bind="props"
          @click="modes.fullscreen = !modes.fullscreen" tile icon size="x-small">
          <v-icon>{{ modes.fullscreen ? 'fullscreen_exit' : 'fullscreen' }}</v-icon>
        </v-btn>
      </template>
      <span>{{ modes.fullscreen ? 'Réduire' : 'Plein écran' }}</span>
    </v-tooltip>
  </div>
</template>

<script setup lang="ts">
import { mergeProps } from 'vue'

const props = defineProps<{
  panzoomInstance: any,
  modes: {
    fullscreen: boolean
    placeMode: boolean
    blockMode: boolean
    commentMode: boolean
  },
  archived: boolean
}>()

const panzoomInstance = toRef(props, 'panzoomInstance')

const zoomIn = () => {
  panzoomInstance.value?.smoothZoom(0, 0, 1.5);
}

const zoomOut = () => {
  panzoomInstance.value?.smoothZoom(0, 0, 0.75);
}

const changeMode = (modeToChange: string) => {
  for (const mode in props.modes) {
    if (mode === modeToChange) {
      // @ts-ignore
      props.modes[mode] = !props.modes[mode];
    } else if (mode !== 'fullscreen') {
      // @ts-ignore
      props.modes[mode] = false;
    }
  }
}
</script>

<style lang="scss">
@import "../../../../assets/variables.scss";

.seats-layout--fullscreen .seats-actions {
  right: 16px;
  top: 16px;
}

.seats-actions {
  position: absolute;
  right: 0;
  top: 0;
  z-index: 1;
}
</style>
